import * as React from 'react';

import {useControlledState} from '@react-stately/utils';

interface Props {
  keys: string[];
}

interface HorizontalLayoutState {
  sizes: Record<string, [number, number]>;
  setSize: (key: string, size: [number, number]) => void;
  getSize: (key: string) => [number, number];
}

export function useHorizontalLayout(props: Props): HorizontalLayoutState {
  // const [sizes, setSizes] = React.useState<Record<string, [number, number]>>({});

  const handleSelectedChange = () => {};

  const [sizes, setSizes] = React.useState<Record<string, [number, number]>>({});

  // const handleSetSize = (key: string, size: [number, number]) => {
  //   setSizes({
  //     ...sizes,
  //     [key]: size,
  //   })
  // };

  const handleSetSize = React.useCallback((key: string, size: [number, number]) => {
    console.log('calllllllxxxx', key, size);

    if (key in sizes && sizes[key] === size) {
      return;
    }

    setSizes( {
      ...sizes,
      [key]: size,
    } );
  }, [sizes]);

  console.log('sizessizessizes: ', sizes);

  const getSize = (key: string) => {
    if (key in sizes) {
      return sizes[key];
    }

    return [50, 50];
  };

  return {
    sizes,
    setSize: handleSetSize,
    getSize,
  };
}
